<?php

    require_once __DIR__ . '/catchexception.php';
    // include db connect class
    require_once __DIR__ . '/db_config.php';
    // array for JSON response
    $response = array();
    if (!isset($_GET['branchcode']) || !isset($_GET['fromdate']) || !isset($_GET['todate'])) {
        $response["success"] = 0;
        $response["message"] = "Required field(s) is missing";

        echo json_encode($response, JSON_UNESCAPED_UNICODE);
        die;
    }

    $branchcode = ($_GET['branchcode']);
    $fromdate = ($_GET['fromdate']);
    $todate = ($_GET['todate']);
    date_default_timezone_set('Asia/Kolkata');

    try{
        if ($branchcode != "" && $fromdate != "" && $todate != "") {
            $paraquery = "SELECT a.voucherno,a.transactiondate,a.createddate,
                                coalesce(CAST((a.basicamount) AS DECIMAL(1000, 2)),0)  as gross_sales_amount,
                                coalesce(CAST((netamount) AS DECIMAL(1000, 2)),0)  as netamount,salestime,
                                coalesce(CAST((discamount) AS DECIMAL(1000, 2)),0) as discount,
                                coalesce(customermobileno,'') as mobilenumber,coalesce(customername,'') as customername,
                                coalesce(cgstamount,0) as cgst,coalesce(sgstamount,0) as sgst,
                                (coalesce(cgstamount,0) + coalesce(sgstamount,0)) as totalTaxAmount,
                                sum(b.qty) as totalqty

                                from tblsales as a
                                inner join tblsalesitemdetails as b on b.transactiondate=a.transactiondate and b.voucherno=a.voucherno and b.branchcode=a.branchcode
                                where a.branchcode = $branchcode and 
                                to_char(to_timestamp(a.transactiondate/1000),'yyyy-mm-dd') between '$fromdate' and '$todate' 
                                group by a.createddate,a.voucherno, a.transactiondate,gross_sales_amount,netamount,salestime,discount,mobilenumber,customername,cgst,sgst,totalTaxAmount
                                order by voucherno desc";

            $result = pg_query($con, $paraquery);
            if (!empty($result)) {
                if (pg_num_rows($result) > 0) {
                    // user node
                    $response["Value"] = array();
                
                    while ($row = pg_fetch_assoc($result)) {
                        $mil = $row["transactiondate"];
                        $seconds = ($mil / 1000);

                        $timemil = $row["createddate"];
                        $timeseconds = ($timemil / 1000);

                        $tax = $row["sgst"] + $row["cgst"];
                        $grand_total =$row["netamount"] - $tax;
                        $report = array();
                        
                        $report["LOCATION_CODE"] = "01";
                        $report["TERMINAL_ID"] = "01";
                        $report["SHIFT_NO"] = "01";
                        $report["RCPT_NUM"] = $row["voucherno"];
                        $report["RCPT_DT"] = date("Ymd ",$seconds);
                        $report["BUSINESS_DT"] = date("Ymd",$seconds);
                        $report["RCPT_TM"] = date("His",$timeseconds);
                        $report["INV_AMT"] = $row["netamount"];
                        $report["TAX_AMT"] = sprintf('%0.2f', $tax);
                        $report["RET_AMT"] = 0;
                        $report["TRN_STATUS"] = 'Sales';

                        // push single product into final response array
                        array_push($response["Value"], $report);
                    }
                    // success
                    $response["success"] = 1;

                    // echoing JSON response
                    echo json_encode($response, JSON_UNESCAPED_SLASHES);
                } else {
                    // no user found
                    $response["success"] = 0;
                    $response["message"] = "No Report found";

                    // echo no users JSON
                    echo json_encode($response);
                }
            } else {
                // no user found
                $response["success"] = 0;
                $response["message"] = "No found";

                // echo no users JSON
                echo json_encode($response);
            }
        } else {
            // required field is missing
            $response["success"] = 0;
            $response["message"] = "Required field(s) is missing";

            echo json_encode($response, JSON_UNESCAPED_UNICODE);
        }
        mch_db_release($con);
    } catch(Exception $e) {
        mch_db_release($con);
        echo 'Message: ' .$e->getMessage();
    }
?>